package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState


class EfectoResolverTrampaConAtributo(
    probabilidadExito: Int,
    private val atributo: Atributo,
    private val coste: Int,
    private val stringLogrado: String,
    private val stringFallo: String) : Efecto(probabilidadExito) {
    override fun ejecutar(): String {
        if (atributo == Atributo.Energia && GameState.jugador.atributos[Atributo.Energia]!!<coste){
            return "No tienes energía suficiente para intentar escapar escalando. Necesitas al menos $coste puntos"
        }else if(atributo == Atributo.Investigacion && GameState.jugador.atributos[Atributo.Investigacion]!!<coste) {
            return "No tienes suficientes puntos de investigación para explorar"
        }else{
            GameState.jugador.actualizarAtributo(atributo, -coste)
            return if ((1..100).random() <= probabilidadExito){
                GameState.eventoActual.actualizarFinalizado(true)
                stringLogrado
            }else{
                stringFallo
            }
        }

    }
}